.386p
.MODEL FLAT

	; Sound Blaster interrupt routines, in asm for minimal overhead.

	PUBLIC _dmaAckPort:WORD
	PUBLIC _sbLoIrqInterrupt
	PUBLIC _sbHiIrqInterrupt

.CODE

PIC1MODE	EQU 020h
PIC2MODE	EQU 0A0h
PICEOI		EQU 020h

	; IRQ < 8
	ALIGN 4
_sbLoIrqInterrupt PROC FAR
	push ax
	push dx
	; -------------------
	mov dx,cs:_dmaAckPort	; acknowledge audio DMA
	in al,dx
	; -------------------
	mov al,PICEOI
	out PIC1MODE,al		; send EOI to PIC #1
	; -------------------
	pop dx
	pop ax
	iretd
_sbLoIrqInterrupt ENDP

	; IRQ >= 8
	ALIGN 4
_sbHiIrqInterrupt PROC FAR
	push ax
	push dx
	; -------------------
	mov dx,cs:_dmaAckPort	; acknowledge audio DMA
	in al,dx
	; -------------------
	mov al,PICEOI
	out PIC2MODE,al		; send EOI to PIC #2
	out PIC1MODE,al		; send EOI to PIC #1
	; -------------------
	pop dx
	pop ax
	iretd
_sbHiIrqInterrupt ENDP

	ALIGN 2
_dmaAckPort:	dw 0

END
