#ifndef __FONT_H__
#define __FONT_H__

#include <stdint.h>

#define FONT_W 8
#define FONT_H 5

// afont.asm

extern uint8_t *Font_GetData(void);
#pragma aux Font_GetData value [EAX]

extern void Font_Print(uint32_t x, uint32_t y, const char *s);
#pragma aux Font_Print parm [EAX] [EBX] [ECX]

extern void Font_Print2Dec(uint32_t x, uint32_t y, uint32_t val);
#pragma aux Font_Print2Dec parm [EAX] [EBX] [ECX]

extern void Font_Print3Dec(uint32_t x, uint32_t y, uint32_t val);
#pragma aux Font_Print3Dec parm [EAX] [EBX] [ECX]

extern void Font_PrintChar(uint32_t x, uint32_t y, uint32_t val);
#pragma aux Font_PrintChar parm [EAX] [EBX] [ECX]

extern void Font_PrintHexByte(uint32_t x, uint32_t y, uint32_t val);
#pragma aux Font_PrintHexByte parm [EAX] [EBX] [ECX]

extern void Font_PrintHexWord(uint32_t x, uint32_t y, uint32_t val);
#pragma aux Font_PrintHexWord parm [EAX] [EBX] [ECX]


#endif
